/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.DsrMetadataConfigRecord;

import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class DsrMetadataConfig extends TableImpl<DsrMetadataConfigRecord> {

    private static final long serialVersionUID = -1769855035;

    /**
     * The reference instance of <code>DSR_METADATA_CONFIG</code>
     */
    public static final DsrMetadataConfig DSR_METADATA_CONFIG = new DsrMetadataConfig();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<DsrMetadataConfigRecord> getRecordType() {
        return DsrMetadataConfigRecord.class;
    }

    /**
     * The column <code>DSR_METADATA_CONFIG.ID_DSR_METADATA_CONFIG</code>.
     */
    public final TableField<DsrMetadataConfigRecord, Integer> ID_DSR_METADATA_CONFIG = createField("ID_DSR_METADATA_CONFIG", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.ID_COMMERCIAL_OFFER</code>.
     */
    public final TableField<DsrMetadataConfigRecord, Integer> ID_COMMERCIAL_OFFER = createField("ID_COMMERCIAL_OFFER", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.REGEX</code>.
     */
    public final TableField<DsrMetadataConfigRecord, String> REGEX = createField("REGEX", org.jooq.impl.SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.REGEX_CONFIG</code>.
     */
    public final TableField<DsrMetadataConfigRecord, String> REGEX_CONFIG = createField("REGEX_CONFIG", org.jooq.impl.SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.REGEX_REPRESENTATION</code>.
     */
    public final TableField<DsrMetadataConfigRecord, String> REGEX_REPRESENTATION = createField("REGEX_REPRESENTATION", org.jooq.impl.SQLDataType.VARCHAR(255).nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.COUNTRY_CODE</code>.
     */
    public final TableField<DsrMetadataConfigRecord, String> COUNTRY_CODE = createField("COUNTRY_CODE", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.PERIOD_CODE</code>.
     */
    public final TableField<DsrMetadataConfigRecord, String> PERIOD_CODE = createField("PERIOD_CODE", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.START_INDEX_COUNTRY</code>.
     */
    public final TableField<DsrMetadataConfigRecord, Integer> START_INDEX_COUNTRY = createField("START_INDEX_COUNTRY", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.END_INDEX_COUNTRY</code>.
     */
    public final TableField<DsrMetadataConfigRecord, Integer> END_INDEX_COUNTRY = createField("END_INDEX_COUNTRY", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.START_INDEX_PERIOD</code>.
     */
    public final TableField<DsrMetadataConfigRecord, Integer> START_INDEX_PERIOD = createField("START_INDEX_PERIOD", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>DSR_METADATA_CONFIG.END_INDEX_PERIOD</code>.
     */
    public final TableField<DsrMetadataConfigRecord, Integer> END_INDEX_PERIOD = createField("END_INDEX_PERIOD", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * Create a <code>DSR_METADATA_CONFIG</code> table reference
     */
    public DsrMetadataConfig() {
        this(DSL.name("DSR_METADATA_CONFIG"), null);
    }

    /**
     * Create an aliased <code>DSR_METADATA_CONFIG</code> table reference
     */
    public DsrMetadataConfig(String alias) {
        this(DSL.name(alias), DSR_METADATA_CONFIG);
    }

    /**
     * Create an aliased <code>DSR_METADATA_CONFIG</code> table reference
     */
    public DsrMetadataConfig(Name alias) {
        this(alias, DSR_METADATA_CONFIG);
    }

    private DsrMetadataConfig(Name alias, Table<DsrMetadataConfigRecord> aliased) {
        this(alias, aliased, null);
    }

    private DsrMetadataConfig(Name alias, Table<DsrMetadataConfigRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> DsrMetadataConfig(Table<O> child, ForeignKey<O, DsrMetadataConfigRecord> key) {
        super(child, key, DSR_METADATA_CONFIG);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.DSR_METADATA_CONFIG_FK_ID_COMMERCIAL_OFFER_IDX, Indexes.DSR_METADATA_CONFIG_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<DsrMetadataConfigRecord, Integer> getIdentity() {
        return Keys.IDENTITY_DSR_METADATA_CONFIG;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<DsrMetadataConfigRecord> getPrimaryKey() {
        return Keys.KEY_DSR_METADATA_CONFIG_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<DsrMetadataConfigRecord>> getKeys() {
        return Arrays.<UniqueKey<DsrMetadataConfigRecord>>asList(Keys.KEY_DSR_METADATA_CONFIG_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<DsrMetadataConfigRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<DsrMetadataConfigRecord, ?>>asList(Keys.FK_ID_COMMERCIAL_OFFER);
    }

    public CommercialOffers commercialOffers() {
        return new CommercialOffers(this, Keys.FK_ID_COMMERCIAL_OFFER);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataConfig as(String alias) {
        return new DsrMetadataConfig(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataConfig as(Name alias) {
        return new DsrMetadataConfig(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrMetadataConfig rename(String name) {
        return new DsrMetadataConfig(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public DsrMetadataConfig rename(Name name) {
        return new DsrMetadataConfig(name, null);
    }
}
